//Name = Timohy Myers
#include <string>
#include <vector>
#include <iostream>
#include <sstream>
#include <unistd.h>
#include <stdio.h>
using namespace std;

//parse function, given by Dr. Rogers, source at bottom of file
vector<string> parseCmdLine(const string &line);

int main(){
   while (1){
		cout << "$ ";
      char input[256];
      cin.getline(input, 255);
		//I take the input and make it a string object
      string in (input);
      if (in.compare("exit") == 0) break;
      vector<string> output = parseCmdLine(in);
		//initializing most of my flags and indices
      int lastOne = 0;
      int firstOne = 1;
      int inindex = 0;
      int inend = output.size();
      int prev = 0;//To be used later to hold the previous pipes end
      int children = 0;
      while (!lastOne){
         vector<string> command;
         int j = 0;
         int p[2] = {0,0};
         for (; inindex < inend && output[inindex].compare("|") != 0; inindex++){
				string token = (string)output[inindex];
            command.push_back(string(""));
				command[j] = token;
            j++;
         }
         inindex++;//To get the index past the | symbol
         if (inindex > inend){
            lastOne = 1;
         }
         if (!lastOne){
            pipe(p);
         }
         int pid = fork();
         if (pid != 0){//I am the parent
            if (!lastOne) close(p[1]);//close pipes im not going to use
            if (!firstOne) close(prev);
            children ++;//one more
         }
         //NOTE: p[1] is the WRITE end and p[0] is the READ end
         else {//I am the child
            char **args;
				args = new char* [command.size() + 1];
				int sizecom = command.size();
            for (int i = 0; i < sizecom; i++){
               //have to cast off constantness
					args[i] = const_cast<char *>(command[i].c_str());	
            }
            args[command.size()] = NULL;
            if (firstOne && lastOne){
               execvp(args[0],args);
					cout << "-shell: "<<string(args[0])<<": command not found" << endl;
					exit(1);
            }
            else if (firstOne){
               if (dup2(p[1],fileno(stdout)) < 0) {
                  exit(1);
               }
               execvp(args[0],args);
					cout << "-shell: "<<string(args[0])<<": command not found" << endl;
               exit(1);
            }
            else if (lastOne){
               if (dup2(prev, fileno(stdin)) < 0) {
                  exit(1);
               }
               execvp(args[0],args);
					cout << "-shell: "<<string(args[0])<<": command not found" << endl;
               exit(1);
            }
            else{
               if (dup2(prev, fileno(stdin)) < 0) {
                  exit(1);
               }
               if (dup2(p[1],fileno(stdout)) < 0) {
                  exit(1);
               }
               execvp(args[0],args);
					cout << "-shell: "<<string(args[0])<<": command not found" << endl;
               exit(1);
            }
         }
         firstOne = 0;
         prev = p[0];
      }
		int status = 100;
		int ret = 100;
      for (int i = 0; i < children ; i++){
         ret = wait(&status);
      }
   }
	return 0;
}


vector<string> parseCmdLine(const string &line) { 
   // Create a string stream that will read from "line"
   stringstream ss(line, stringstream::in);
   // We will put the token in "answer"
   vector<string> answer;
   int count = 0;
   // While there are more tokens...
   while (ss.peek() > 0) {
      // Put a new string in our vector
      answer.push_back(string(""));
      // Put the next token into the new string
      ss >> answer[count];
      // count it
      count++;
   }
   // return out vector of tokens
   return answer;

}

